SystemOrganization addCategory: #'CV-TestBed'!

TestCase subclass: #CvUsingTbTestCase
	instanceVariableNames: 'codeBasesBeforeTestRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-TestBed'!

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 13:41:05.612'!
activeDict
	^ self activeCodeBase dictionary! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/20/2011 20:13:46.38'!
assert: aBlock basedOn: aCodeBase
	self assert: (aBlock valueBasedOn: aCodeBase)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/20/2011 20:09:35.662'!
assert: anObject differsFrom: anotherObject
	^ self
		assert: (anObject ~= anotherObject)
		description: 'unexpected equality of values'
! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 10:45:38.875'!
assert: aBlock equalsFor: aBlockArg and: anotherBlockArg.
	self assert: (aBlock value: aBlockArg) == (aBlock value: anotherBlockArg)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 21:35:41.87'!
assert: aBlock equalsForCodeBases: aCodeBase and: anotherCodeBase.
	self assert: 
		([aBlock cull: aCodeBase] valueBasedOn: aCodeBase) =
		([aBlock cull: anotherCodeBase] valueBasedOn: anotherCodeBase)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 21:35:37.856'!
assert: aBlock isSameForCodeBases: aCodeBase and: anotherCodeBase.
	self assert: 
		([aBlock cull: aCodeBase] valueBasedOn: aCodeBase) ==
		([aBlock cull: anotherCodeBase] valueBasedOn: anotherCodeBase)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:10:27.067'!
assert: aBlock isUnlikeFor: aBlockArg and: anotherBlockArg.
	self assert: (aBlock value: aBlockArg) ~~ (aBlock value: anotherBlockArg)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 21:27:03.174'!
assert: aBlock isUnlikeForCodeBases: aCodeBase and: anotherCodeBase.
	self assert: 
		([aBlock cull: aCodeBase] valueBasedOn: aCodeBase) ~~
		([aBlock cull: anotherCodeBase] valueBasedOn: anotherCodeBase)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:27:13.245'!
basedOn: aCodeBase assert: aBlock
	self assert: (aBlock valueBasedOn: aCodeBase)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:27:20.418'!
basedOn: aCodeBase deny: aBlock
	self deny: (aBlock valueBasedOn: aCodeBase)! !

!CvUsingTbTestCase methodsFor: 'simulating system events' stamp: 'bs 8/1/2011 15:32:53.376'!
classModifiedEvent: aClass
	
	^ (ModifiedClassDefinitionEvent class: aClass)
		saveCodeReference;
		yourself
		! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/26/2011 11:58:48.128'!
createSubclassOfTbClass

	^ self createSubclassOfTbClassNamed: #CvTbSpecialPerson.! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/26/2011 11:58:10.672'!
createSubclassOfTbClassNamed: aName

	^ self tbClass subclass: aName asSymbol
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: self tbClass category! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:25:34.943'!
deny: aBlock basedOn: aCodeBase
	self deny: (aBlock valueBasedOn: aCodeBase)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:28:42.919'!
deny: expected equals: actual
	^ self
		assert: (expected ~= actual)
		description: 'unexpected equality of values'
! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:25:46.087'!
deny: aBlock forAll: blockArgs
	blockArgs do: [:ea | self deny: [aBlock value: ea]]! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 14:26:47.951'!
polySource
	^ World polySource! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 09:57:33.989'!
psCodeBases
	^ self polySource codeBases! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/26/2011 12:02:45.509'!
removeClassNamed: aSymbol
	
	(self activeDict at: aSymbol) removeFromSystem! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:16:30.817'!
removeClassNamed: aSymbol on: aCodeBase
	self basedOn: aCodeBase do: [
		(self activeDict at: aSymbol) removeFromSystem ]! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/16/2011 16:00:21.4'!
removeMethod: aMethod on: aCodeBase
	^ self basedOn: aCodeBase do: [
		aMethod methodClass removeSelector: aMethod selector ]! !

!CvUsingTbTestCase methodsFor: 'running' stamp: ''!
setUp
	super setUp.
	self assert: [World psIsInstalled].
	"self deny: [World cvIsInstalled]."
	codeBasesBeforeTestRun := self psCodeBases.! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:09.193'!
tbClass
	^ self activeDict at: self tbClassName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 16:53:09.847'!
tbClassCategory
	^ self tbClass category! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:12.443'!
tbClassMethod
	^ self tbClass class >> self tbClassMethodName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:16.869'!
tbClassMethodName
	^ #new! !

!CvUsingTbTestCase methodsFor: 'simulating system events' stamp: 'bs 8/1/2011 15:33:15.6'!
tbClassModifiedEvent
	
	^ self classModifiedEvent: self tbClass
		! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:20.285'!
tbClassName
	^ #CvTbPerson ! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:38:51.897'!
tbMethod
	^ self tbClass >> self tbMethodName! !

!CvUsingTbTestCase methodsFor: 'simulating system events' stamp: 'bs 7/31/2011 18:17:11.554'!
tbMethodAddedEvent
	^ (AddedEvent
		method: self tbMethod
		selector: self tbMethodName
		protocol: self tbMethodProtocol
		class: self tbClass
		requestor: nil)
			saveCodeReference;
			yourself
		! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/27/2011 18:42:15.741'!
tbMethodCategory
	^ self tbClass organization categoryOfElement: self tbMethodName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:38:44.335'!
tbMethodName
	^ #firstname! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 10:50:58.355'!
tbMethodProtocol
	^ self tbClass organization categoryOfElement: self tbMethodName! !

!CvUsingTbTestCase methodsFor: 'simulating system events' stamp: 'bs 7/31/2011 18:17:17.492'!
tbMethodRemovedEvent
	^ (RemovedEvent
		method: self tbMethod
		selector: self tbMethodName
		protocol: self tbMethodProtocol
		class: self tbClass)
			saveCodeReference;
			yourself
		! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 16:54:57.639'!
tbObjectClass
	^ self activeDict at: self tbObjectClassName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 16:54:44.602'!
tbObjectClassName
	^ #CvTbObject! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2011 10:54:36.959'!
tbPackageInfo
	^ PackageOrganizer default packageOfClass: self tbClass! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2011 10:56:48.844'!
tbPackageName
	^ self tbPackageInfo name! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:26:15.69'!
tbRootClassName
	
	^ CvTbObject name! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 16:15:38.804'!
tbSubclass
	^ self activeDict at: self tbSubclassName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/27/2011 18:53:20.592'!
tbSubclassCategory
	^ self tbSubclass category! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 16:15:25.728'!
tbSubclassName
	^ #CvTbEmployee! !

!CvUsingTbTestCase methodsFor: 'simulating system events' stamp: 'bs 7/31/2011 18:17:26.73'!
tbSubclassRemovedEvent
	^ (RemovedEvent 
		class: self tbSubclass
		category: self tbClassCategory)
			backup: self tbSubclass copy;
			saveCodeReference;
			yourself! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:38:42.364'!
tbTestClass
	^ self activeDict at: self tbTestClassName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:38:31.429'!
tbTestClassName
	^ #CvTbPersonTest! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 10:42:21.497'!
tbTestMethod
	^ self tbClass >> self tbTestMethodName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 10:42:08.207'!
tbTestMethodName
	^ #testFirstname! !

!CvUsingTbTestCase methodsFor: 'running' stamp: 'bs 3/16/2011 14:37:49.126'!
tearDown
	(self psCodeBases copyWithoutAll: codeBasesBeforeTestRun) 
		do: [:ea | self polySource removeCodeBase: ea].
	
	super tearDown! !

Object subclass: #CvTbGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-TestBed'!

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 8/12/2011 14:49:48.929'!
createLastnameSlot
	
	CvTbPerson 
		addInstVarName: 'lastname';
		compile: 'lastname
			^ lastname ifNil: [''foo'']';
		compile: 'lastname: anObject
			lastname := anObject'.! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 1/17/2012 18:20:34.343'!
createTestForLastnameSlot
	| aSymbol |
	aSymbol := CvTbPersonTest compile: 'testLastname
		| sut |
		sut := CvTbPerson new.
		sut lastname: ''Foo''.
		self assert: ''Foo'' equals: sut lastname'.
	^ CvTbPersonTest >> aSymbol! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 1/13/2012 10:02:12.988'!
generateChanges
		
	self 
		createTestForLastnameSlot;
		createLastnameSlot;
		removeLastnameSlot;
		removeTestForLastnameSlot! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: ''!
generateChangesOn: aWorkingCopy
	| firstVersion fourthVersion secondVersion thirdVersion |
	firstVersion := aWorkingCopy baseVersion.
	
	self basedOn: aWorkingCopy do: [	
		CvTbPersonTest compile: 'testLastname
			| sut |
			sut := CvTbPerson new.
			sut lastname: ''Foo''.
			self assert: ''Foo'' equals: sut lastname'.
			
		CvTbPerson addInstVarName: 'lastname'.
	
		CvTbPerson compile: 'lastname
			^ lastname ifNil: [''foo'']'.
	
		CvTbPerson compile: 'lastname: anObject
			lastname := anObject'].
	
	secondVersion := firstVersion successors first.
	thirdVersion := secondVersion successors first.
	fourthVersion := thirdVersion successors first.
	
	firstVersion versionInfo instVarNamed: 'time' put: (Time now subtractTime: (Time seconds: 400)).
	secondVersion versionInfo instVarNamed: 'time' put: (Time now subtractTime: (Time seconds: 390)).
	thirdVersion versionInfo instVarNamed: 'time' put: (Time now subtractTime: (Time seconds: 330)).
	fourthVersion versionInfo instVarNamed: 'time' put: (Time now subtractTime: (Time seconds: 300)).! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 8/23/2011 09:59:20.16'!
generateManyChanges
	
	| testLastnameSource aNewClass |
	testLastnameSource := 'testLastname
		| sut |
		sut := CvTbPerson new.
		sut lastname: ''Foo''.
		self assert: ''Foo'' equals: sut lastname'.
		
	CvTbPersonTest 
		compile: testLastnameSource;
		compile: testLastnameSource;
		compile: testLastnameSource.
	
	self 
		createLastnameSlot;
		renameInstVarLastnameToFoo;
		renameInstVarFooToLastname;
		removeLastnameSlot.
	
	CvTbPersonTest removeSelector: #testLastname.
	aNewClass := CvTbPerson newSubclass.
	aNewClass removeFromSystem.! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 4/11/2011 11:09:27.465'!
generateMoreChanges
	
	CvTbPersonTest compile: 'testLastname
		| sut |
		sut := CvTbPerson new.
		sut lastname: ''Foo''.
		self assert: ''Foo'' equals: sut lastname'.
	
	CvTbPerson compile: 'lastname
		^ lastname ifNil: [''foo'']'.
	
	CvTbPerson compile: 'lastname: anObject
		lastname := anObject'.! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 8/12/2011 14:50:12.623'!
removeLastnameSlot
	
	CvTbPerson 
		removeSelector: #lastname:;
		removeSelector: #lastname;
		removeInstVarName: 'lastname'.! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 1/13/2012 10:01:03.699'!
removeTestForLastnameSlot

	CvTbPersonTest removeSelector: #testLastname.! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 8/12/2011 14:53:55.303'!
renameInstVarFooToLastname
	
	(RenameInstanceVariableRefactoring 
		rename: 'foo' to: 'lastname' in: CvTbPerson)
			execute! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 8/12/2011 14:53:58.029'!
renameInstVarLastnameToFoo
	
	(RenameInstanceVariableRefactoring 
		rename: 'lastname' to: 'foo' in: CvTbPerson)
			execute! !

Object subclass: #CvTbObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-TestBed'!

!CvTbObject class methodsFor: 'as yet unclassified' stamp: 'bs 5/20/2011 14:45:33.179'!
wantsRecompilationProgressReported
	"Answer whether the receiver would like progress of its recompilation reported interactively to the user."

	^ false! !

CvTbObject subclass: #CvTbPerson
	instanceVariableNames: 'firstname'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'CV-TestBed'!

CvTbPerson subclass: #CvTbEmployee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-TestBed'!

!CvTbPerson class methodsFor: 'as yet unclassified' stamp: ''!
createNewDefault
	"self setValue."
	Default := nil.
	Default := CvTbPerson new! !

!CvTbPerson class methodsFor: 'as yet unclassified' stamp: ''!
default
	
	^ Default! !

!CvTbPerson class methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:45:56.897'!
new
	^ super new! !

!CvTbPerson methodsFor: 'accessing' stamp: 'cr 1/19/2013 14:10:50.315'!
firstname
	"change in a http repository"
	^ firstname ifNil: ['foo'] ! !

!CvTbPerson methodsFor: 'accessing' stamp: 'cr 1/19/2013 14:10:58.142'!
firstname: anObject
	"change number 2"
	firstname := anObject " "  ! !

CvTbObject subclass: #CvTbTestCase
	instanceVariableNames: 'testSelector timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-TestBed'!

CvTbTestCase class
	instanceVariableNames: 'history'!

CvTbTestCase class
	instanceVariableNames: 'history'!

CvTbTestCase subclass: #CvTbPersonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-TestBed'!

!CvTbPersonTest methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 14:35:40.799'!
testFirstname
	| sut |
	sut := CvTbPerson new.
	sut firstname: 'Foo'.
	self assert: 'Foo' equals: sut firstname.! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.439'!
addTestsFor: classNameString toSuite: suite

	| cls  |
	cls := Smalltalk at: classNameString ifAbsent: [ ^suite ].
	^cls isAbstract 
		ifTrue:  [
			cls allSubclasses do: [ :each |
				each isAbstract ifFalse: [
					each addToSuiteFromSelectors: suite ] ].
			suite]
		ifFalse: [ cls addToSuiteFromSelectors: suite ]
! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.449'!
addToSuite: suite fromMethods: testMethods 
	testMethods do:  [ :selector | 
			suite addTest: (self selector: selector) ].
	^suite! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.445'!
addToSuiteFromSelectors: suite
	^self addToSuite: suite fromMethods: (self shouldInheritSelectors
		ifTrue: [ self allTestSelectors ]
		ifFalse: [self testSelectors ])! !

!CvTbTestCase class methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.419'!
allTestSelectors

	^(self allSelectors asArray select: [ :each | 
		(each beginsWith: 'test') and: [ each numArgs isZero ] ]) sort
			! !

!CvTbTestCase class methodsFor: 'ob-sunitintegration' stamp: 'bs 5/22/2011 12:53:14.826'!
browserIcon
	| classHistory |
	self isAbstract
		ifTrue: [ ^ super browserIcon ].
	classHistory := TestResult historyFor: self.
	(classHistory at: #errors) isEmpty
		ifFalse: [ ^ #testRed ].
	(classHistory at: #failures) isEmpty
		ifFalse: [ ^ #testOrange ].
	(classHistory at: #passed) isEmpty
		ifFalse: [ ^ #testGreen ].
	^ #testGray! !

!CvTbTestCase class methodsFor: 'ob-sunitintegration' stamp: 'bs 5/22/2011 12:53:14.832'!
browserIcon: aClassDescription selector: aSelector
	(aClassDescription isMeta or: [ aClassDescription isAbstract or: [ (aSelector beginsWith: 'test') not ] ])
		ifTrue: [ ^ super browserIcon: aClassDescription selector: aSelector ].
	(aClassDescription methodRaisedError: aSelector)
		ifTrue: [ ^ #testRed ].
	(aClassDescription methodFailed: aSelector)
		ifTrue: [ ^ #testOrange ].
	(aClassDescription methodPassed: aSelector)
		ifTrue: [ ^ #testGreen ].
	^ #testGray! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.456'!
buildSuite
	| suite |
	suite := TestSuite new.
	^ self isAbstract
		ifTrue: [
			suite name: self name asString.
			self allSubclasses
				do: [:each | each isAbstract
						ifFalse: [each addToSuiteFromSelectors: suite]].
			suite]
		ifFalse: [self addToSuiteFromSelectors: suite]! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.462'!
buildSuiteFromAllSelectors

	^self buildSuiteFromMethods: self allTestSelectors
			! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.47'!
buildSuiteFromLocalSelectors

	^self buildSuiteFromMethods: self testSelectors
			! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.48'!
buildSuiteFromMethods: testMethods 
	| suite |
	suite := (TestSuite new)
				name: self name asString;
				yourself.
	^self addToSuite: suite fromMethods: testMethods! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.484'!
buildSuiteFromSelectors

	^self shouldInheritSelectors
		ifTrue: [self buildSuiteFromAllSelectors]
		ifFalse: [self buildSuiteFromLocalSelectors]
			! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.673'!
coverage
	"returns the coverage determined by a simple static analysis of test coverage 
	made by the receiver on a class that is identified by the name of the receiver.
	We assume that SetTest test Set."
	
	| cls className |
	(self name endsWith: 'Test') ifFalse: [self error: 'Please, use #coverageForClass: instead'].

	className := self name copyFrom: 1 to: (self name size - 'Test' size).
	cls := Smalltalk at: className asSymbol ifAbsent: [self error: 'Please, use #coverageForClass: instead'].
	
	"May happen with Transcript"
	cls isBehavior ifFalse: [cls := cls class].
	
	^ self coverageForClass: cls! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.681'!
coverageAsString
	| cov className |
	cov := self coverage first asInteger. 
	"coverage already checks that the name is ends with 'Test' and if the class tested exists"
	
	className := self name copyFrom: 1 to: (self name size - 'Test' size).
	^ self name asString, ' covers ', cov asString, '% of ', className.! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.687'!
coverageForClass: cls
	"returns the test coverage of all the methods included inherited ones"
	^ self coverageForClass: cls until: ProtoObject! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.699'!
coverageForClass: cls until: aRootClass
	"returns the test coverage of all the methods included inherited ones but stopping at aRootClass included"
	
	| definedMethods testedMethods untestedMethods |
	definedMethods := cls allSelectorsAboveUntil: aRootClass.
	definedMethods size = 0
		ifTrue: [^ {0. Set new}].
	testedMethods := 
		self methodDictionary inject: Set new into: 
							[:sums :cm | sums union: cm messages].
	testedMethods := testedMethods reject: [:sel | (definedMethods includes: sel) not].
	untestedMethods := definedMethods select: [:selector | (testedMethods includes: selector) not].
	^ { (testedMethods size * 100 / definedMethods size) asFloat . untestedMethods}
! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.705'!
coveragePercentage
	^ self coverage first! !

!CvTbTestCase class methodsFor: 'instance creation' stamp: 'bs 5/22/2011 12:53:14.496'!
debug: aSymbol

	^(self selector: aSymbol) debug
			! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.741'!
generateLastStoredRunMethod

	self shouldGenerateLastStoredRunMethod ifTrue: [
		self class
			compile: (self lastRunMethodNamed: #lastStoredRun)
			classified: 'history' ]! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.525'!
hasMethodBeenRun: aSelector
	^ ((self lastRun at: #errors),
		(self lastRun at: #failures),
		(self lastRun at: #passed))
			includes: aSelector! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.747'!
history
	^ history ifNil: [ history := self newTestDictionary ]! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.753'!
history: aDictionary
	history := aDictionary! !

!CvTbTestCase class methodsFor: 'initialize - event' stamp: 'bs 5/22/2011 12:53:14.796'!
initialize
     super initialize.
	SystemChangeNotifier uniqueInstance notify: self ofSystemChangesOfItem: #method using: #methodChanged:.! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.529'!
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self name = #TestCase
			! !

!CvTbTestCase class methodsFor: 'SwaUtil' stamp: 'bs 5/22/2011 12:53:14.839'!
isTestCaseClass
	^ true! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.757'!
lastRun
	^ TestResult historyFor: self! !

!CvTbTestCase class methodsFor: 'history' stamp: ''!
lastRunMethodNamed: aSelector
	
	^ String streamContents: [:str |
		str nextPutAll: aSelector asString ;cr.
		str tab; nextPutAll: '^ ', (self lastRun) storeString]
! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.769'!
lastStoredRun
	^ ((Dictionary new) add: (#failures->#()); add: (#passed->#()); add: (#errors->#()); yourself)! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.715'!
localCoverage
	"returns the coverage determined by a simple static analysis of test coverage 
	made by the receiver on a class that is identified by the name of the receiver.
	We assume that SetTest test Set. The computation of the coverage takes only into
	account the methods defined locally in the tested class. See coverage for a more global 
	coverage"
	
	| cls className |
	(self name endsWith: 'Test') ifFalse: [self error: 'Please, use #localCoverageForClass: instead'].
	className := self name copyFrom: 1 to: (self name size - 'Test' size).
	cls := Smalltalk at: className asSymbol ifAbsent: [self error: 'Please, use #localCoverageForClass: instead'].
	cls isBehavior ifFalse: [cls := cls class].
	^ self localCoverageForClass: cls! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.721'!
localCoverageAsString
	| cov className |
	cov := self localCoverage first asInteger. 
	"coverage already checks that the name is ends with 'Test' and if the class tested exists"
	
	className := self name copyFrom: 1 to: (self name size - 'Test' size).
	^ self name asString, ' covers ', cov asString, '% of ', className.! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.729'!
localCoverageForClass: cls
	
	| definedMethods testedMethods untestedMethods |
	definedMethods := cls selectors asSet.
	"It happens for IdentityBag / IdentityBagTest"
	definedMethods size = 0
		ifTrue: [^ {0. Set new}].

	testedMethods := 
		self methodDictionary inject: Set new into: 
							[:sums :cm | sums union: cm messages].
					
	"testedMethods contains all the methods send in test methods, which probably contains methods that have nothign to do with collection"
	testedMethods := testedMethods reject: [:sel | (definedMethods includes: sel) not].

	untestedMethods := definedMethods select: [:selector | (testedMethods includes: selector) not].

	^ { (testedMethods size * 100 / definedMethods size) asFloat . untestedMethods}
! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.735'!
localCoveragePercentage
	^ self localCoverage first! !

!CvTbTestCase class methodsFor: 'initialize - event' stamp: 'bs 5/22/2011 12:53:14.802'!
methodChanged: anEvent
	"Remove the changed method from the known test results."
	
	| cls sel |
	anEvent item isCompiledMethod ifFalse: [ ^ self ].
	cls := anEvent item methodClass.
	(cls inheritsFrom: TestCase)
		ifFalse: [^ self].
	sel := anEvent item selector.
	(sel beginsWith: 'test')
		ifFalse: [^ self].
	TestResult removeFromTestHistory: sel in: cls.
! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.533'!
methodFailed: aSelector
	^ (self lastRun at: #failures) includes: aSelector! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.539'!
methodPassed: aSelector
	^ (self lastRun at: #passed) includes: aSelector! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.545'!
methodProgressed: aSelector
	^ ((self storedMethodRaisedError: aSelector) or: [self storedMethodFailed: aSelector])
		and: [self methodPassed: aSelector]
		! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.549'!
methodRaisedError: aSelector
	^ (self lastRun at: #errors) includes: aSelector! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.555'!
methodRegressed: aSelector
	^ (self storedMethodPassed: aSelector) and: [(self methodFailed: aSelector) or: [self methodRaisedError: aSelector]]! !

!CvTbTestCase class methodsFor: 'history' stamp: ''!
newTestDictionary

	^ Dictionary new at: #timeStamp put: TimeStamp now;
		at: #passed put: Set new;
		at: #failures put: Set new;
		at: #errors put: Set new;
		yourself
		! !

!CvTbTestCase class methodsFor: 'sunitgui' stamp: 'bs 5/22/2011 12:53:14.81'!
packageNamesUnderTest
	"Answer a collection of package names under test. This is used by the test runner to automatically instrument the code in these packages when checking for test coverage."
	
	^ #()! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.786'!
resetHistory
	history := nil! !

!CvTbTestCase class methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.425'!
resources

	^#()
			! !

!CvTbTestCase class methodsFor: 'instance creation' stamp: 'bs 5/22/2011 12:53:14.502'!
run: aSymbol

	^(self selector: aSymbol) run
			! !

!CvTbTestCase class methodsFor: 'instance creation' stamp: 'bs 5/22/2011 12:53:14.508'!
selector: aSymbol

	^self new setTestSelector: aSymbol
			! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.79'!
shouldGenerateLastStoredRunMethod
	| sameRun |
	
	(self class methodDictionary includesKey: #lastStoredRun)
		ifFalse: [^ true].
	sameRun := #(#passed #failures #errors) inject: true into: 
		[ :ok :set | ok and: [(self lastRun at: set) = (self lastStoredRun at: set) ]].
	^ sameRun not
! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.566'!
shouldInheritSelectors
	"I should inherit from an Abstract superclass but not from a concrete one by default, unless I have no testSelectors in which case I must be expecting to inherit them from my superclass.  If a test case with selectors wants to inherit selectors from a concrete superclass, override this to true in that subclass."

	^self superclass isAbstract
		or: [self testSelectors isEmpty]

"$QA Ignore:Sends system method(superclass)$"
			! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.572'!
storedMethodFailed: aSelector
	^ (self lastStoredRun at: #failures) includes: aSelector! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.661'!
storedMethodPassed: aSelector
	^ (self lastStoredRun at: #passed) includes: aSelector! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.667'!
storedMethodRaisedError: aSelector
	^ (self lastStoredRun at: #errors) includes: aSelector! !

!CvTbTestCase class methodsFor: 'instance creation' stamp: 'bs 5/22/2011 12:53:14.514'!
suite

	^self buildSuite
			! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.49'!
suiteClass
	^TestSuite
			! !

!CvTbTestCase class methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.431'!
sunitVersion
	^'3.1'
			! !

!CvTbTestCase class methodsFor: 'SwaUtil' stamp: 'bs 5/22/2011 12:53:14.843'!
testMethods
	^ self methodDict values asIdentitySet select: [ :m | m isTestMethod ]! !

!CvTbTestCase class methodsFor: 'Accessing' stamp: 'bs 5/22/2011 12:53:14.814'!
testSelectors

	^(self selectors asArray select: [ :each | 
		(each beginsWith: 'test') and: [ each numArgs isZero ] ]) sort! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 13:41:05.612'!
activeDict
	^ self activeCodeBase dictionary! !

!CvTbTestCase methodsFor: 'dependencies' stamp: 'bs 5/22/2011 12:53:14.242'!
addDependentToHierachy: anObject 
	"an empty method. for Composite compability with TestSuite"


			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:13.997'!
assert: aBooleanOrBlock

	aBooleanOrBlock value ifFalse: [self signalFailure: 'Assertion failed']
			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/20/2011 20:13:46.38'!
assert: aBlock basedOn: aCodeBase
	self assert: (aBlock valueBasedOn: aCodeBase)! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.005'!
assert: aBooleanOrBlock description: aString
	aBooleanOrBlock value ifFalse: [
		self logFailure: aString.
		TestResult failure signal: aString]
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.013'!
assert: aBooleanOrBlock description: aString resumable: resumableBoolean 
	| exception |
	aBooleanOrBlock value
		ifFalse: 
			[self logFailure: aString.
			exception := resumableBoolean
						ifTrue: [TestResult resumableFailure]
						ifFalse: [TestResult failure].
			exception signal: aString]
			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/20/2011 20:09:35.662'!
assert: anObject differsFrom: anotherObject
	^ self
		assert: (anObject ~= anotherObject)
		description: 'unexpected equality of values'
! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.019'!
assert: expected equals: actual
	^ self
		assert: (expected = actual)
		description: (self comparingStringBetween: expected and: actual)
! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 10:45:38.875'!
assert: aBlock equalsFor: aBlockArg and: anotherBlockArg.
	self assert: (aBlock value: aBlockArg) == (aBlock value: anotherBlockArg)! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 21:35:41.87'!
assert: aBlock equalsForCodeBases: aCodeBase and: anotherCodeBase.
	self assert: 
		([aBlock cull: aCodeBase] valueBasedOn: aCodeBase) =
		([aBlock cull: anotherCodeBase] valueBasedOn: anotherCodeBase)! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 21:35:37.856'!
assert: aBlock isSameForCodeBases: aCodeBase and: anotherCodeBase.
	self assert: 
		([aBlock cull: aCodeBase] valueBasedOn: aCodeBase) ==
		([aBlock cull: anotherCodeBase] valueBasedOn: anotherCodeBase)! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:10:27.067'!
assert: aBlock isUnlikeFor: aBlockArg and: anotherBlockArg.
	self assert: (aBlock value: aBlockArg) ~~ (aBlock value: anotherBlockArg)! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 21:27:03.174'!
assert: aBlock isUnlikeForCodeBases: aCodeBase and: anotherCodeBase.
	self assert: 
		([aBlock cull: aCodeBase] valueBasedOn: aCodeBase) ~~
		([aBlock cull: anotherCodeBase] valueBasedOn: anotherCodeBase)! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:27:13.245'!
basedOn: aCodeBase assert: aBlock
	self assert: (aBlock valueBasedOn: aCodeBase)! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:27:20.418'!
basedOn: aCodeBase deny: aBlock
	self deny: (aBlock valueBasedOn: aCodeBase)! !

!CvTbTestCase methodsFor: 'private' stamp: ''!
comparingStringBetween: expected and: actual
	^ String streamContents: [:stream |
		stream
			nextPutAll: 'Expected ';
			nextPutAll: (expected printStringLimitedTo: 10);
			nextPutAll: ' but was ';
			nextPutAll: (actual printStringLimitedTo: 10);
			nextPutAll: '.'
		]! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.258'!
debug
	self resources do: [:res | 
		res isAvailable ifFalse: [^res signalInitializationError]].
	[(self class selector: testSelector) runCase] 
		ensure: [self resources do: [:each | each reset]]
			! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.264'!
debugAsFailure
	| semaphore |
	semaphore := Semaphore new.
	self resources do: [:res | 
		res isAvailable ifFalse: [^res signalInitializationError]].
	[semaphore wait. self resources do: [:each | each reset]] fork.
	(self class selector: testSelector) runCaseAsFailure: semaphore.! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.026'!
defaultTimeout
	"Answer the default timeout to use for tests in this test case.
	The timeout is a value in seconds."

	^5 "seconds"! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.032'!
deny: aBooleanOrBlock

	self assert: aBooleanOrBlock value not
			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:25:34.943'!
deny: aBlock basedOn: aCodeBase
	self deny: (aBlock valueBasedOn: aCodeBase)! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.04'!
deny: aBooleanOrBlock description: aString
	self assert: aBooleanOrBlock value not description: aString
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.044'!
deny: aBooleanOrBlock description: aString resumable: resumableBoolean 
	self
		assert: aBooleanOrBlock value not
		description: aString
		resumable: resumableBoolean
			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:28:42.919'!
deny: expected equals: actual
	^ self
		assert: (expected ~= actual)
		description: 'unexpected equality of values'
! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:25:46.087'!
deny: aBlock forAll: blockArgs
	blockArgs do: [:ea | self deny: [aBlock value: ea]]! !

!CvTbTestCase methodsFor: 'private' stamp: 'bs 5/22/2011 12:53:14.35'!
executeShould: aBlock inScopeOf: anExceptionalEvent 
	^[aBlock value.
 	false] on: anExceptionalEvent
		do: [:ex | ex return: true]
			! !

!CvTbTestCase methodsFor: 'private' stamp: 'bs 5/22/2011 12:53:14.354'!
executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: aString
	^[aBlock value.
 	false] on: anExceptionalEvent
		do: [:ex | ex return: (ex description includesSubString: aString) ]
			! !

!CvTbTestCase methodsFor: 'private' stamp: 'bs 5/22/2011 12:53:14.362'!
executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: aString
	^[aBlock value.
 	false] on: anExceptionalEvent
		do: [:ex | ex return: (ex description includesSubString: aString) not ]
			! !

!CvTbTestCase methodsFor: 'extensions' stamp: 'bs 5/22/2011 12:53:14.379'!
executeShould: aBlock inScopeOf: anException withExceptionDo: anotherBlock

	^[aBlock value.
 	false] 
		on: anException
		do: [:exception | 
			anotherBlock value: exception.
			exception return: true]! !

!CvTbTestCase methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.333'!
expectedFailures
	^ Array new! !

!CvTbTestCase methodsFor: 'extensions' stamp: 'bs 5/22/2011 12:53:14.385'!
fail

	^self assert: false! !

!CvTbTestCase methodsFor: 'running' stamp: ''!
failureLog	
	^Transcript

			! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.276'!
isLogging
	"By default, we're not logging failures. If you override this in 
	a subclass, make sure that you override #failureLog"
	^false
			! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.286'!
logFailure: aString
	self isLogging ifTrue: [
		self failureLog 
			cr; 
			nextPutAll: aString; 
			flush]
			! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.29'!
openDebuggerOnFailingTestMethod
	"SUnit has halted one step in front of the failing test method. Step over the 'self halt' and 
	 send into 'self perform: testSelector' to see the failure from the beginning"

	self
		halt;
		performTest! !

!CvTbTestCase methodsFor: 'private' stamp: 'bs 5/22/2011 12:53:14.366'!
performTest

	self perform: testSelector asSymbol
			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 14:26:47.951'!
polySource
	^ World polySource! !

!CvTbTestCase methodsFor: 'printing' stamp: 'bs 5/22/2011 12:53:14.252'!
printOn: aStream

	aStream
		nextPutAll: self class printString;
		nextPutAll: '>>#';
		nextPutAll: testSelector
			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 09:57:33.989'!
psCodeBases
	^ self polySource codeBases! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:16:30.817'!
removeClassNamed: aSymbol on: aCodeBase
	self basedOn: aCodeBase do: [
		(self activeDict at: aSymbol) removeFromSystem ]! !

!CvTbTestCase methodsFor: 'dependencies' stamp: 'bs 5/22/2011 12:53:14.246'!
removeDependentFromHierachy: anObject 
	"an empty method. for Composite compability with TestSuite"


			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/16/2011 16:00:21.4'!
removeMethod: aMethod on: aCodeBase
	^ self basedOn: aCodeBase do: [
		aMethod methodClass removeSelector: aMethod selector ]! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.048'!
resources
	| allResources resourceQueue |
	allResources := Set new.
	resourceQueue := OrderedCollection new.
	resourceQueue addAll: self class resources.
	[resourceQueue isEmpty] whileFalse: [
		| next |
		next := resourceQueue removeFirst.
		allResources add: next.
		resourceQueue addAll: next resources].
	^allResources
			! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.299'!
run
	| result |
	result := TestResult new.
	self run: result.
	^result
			! !

!CvTbTestCase methodsFor: 'CV-override' stamp: 'bs 5/22/2011 12:53:14.415'!
run: aResult 
	| originalRunCode | 
	originalRunCode := [aResult runCase: self].
	self activeCodeBase 
		ifNil: [originalRunCode value]
		ifNotNil: [:codeBase | 
			originalRunCode valueBasedOn: codeBase testCodeBase]
! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.303'!
runCase
	"Run this TestCase. Time out if the test takes too long."

	[self timeout: [self setUp]
		after: self timeoutForSetUp.
	self timeout: [self performTest]
		after: self timeoutForTest]
		ensure: [self tearDown]! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.309'!
runCaseAsFailure: aSemaphore
	[self setUp.
	self openDebuggerOnFailingTestMethod] ensure: [
		self tearDown.
		aSemaphore signal]! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.054'!
selector
	^testSelector
			! !

!CvTbTestCase methodsFor: 'private' stamp: 'bs 5/22/2011 12:53:14.373'!
setTestSelector: aSymbol
	testSelector := aSymbol
			! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.315'!
setUp! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.06'!
should: aBlock
	self assert: aBlock value
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.065'!
should: aBlock description: aString
	self assert: aBlock value description: aString
			! !

!CvTbTestCase methodsFor: 'extensions' stamp: ''!
should: aBlock notTakeMoreThan: aDuration
    "Evaluate aBlock in a forked process and if it takes more than anInteger milliseconds
    to run we terminate the process and report a test failure.  It'' important to
    use the active process for the test failure so that the failure reporting works correctly
    in the context of the exception handlers."

    | evaluated evaluationProcess result delay testProcess |

    evaluated := false.
    delay := Delay forDuration: aDuration.
    testProcess := Processor activeProcess.
    "Create a new process to evaluate aBlock"
    evaluationProcess := [
        result := aBlock value.
        evaluated := true.
        delay unschedule.
        testProcess resume ] forkNamed: 'Process to evaluate should: notTakeMoreThanMilliseconds:'.

    "Wait the milliseconds they asked me to"
    delay wait.
    "After this point either aBlock was evaluated or not..."
    evaluated ifFalse: [
        evaluationProcess terminate.
        self assert: false description: ('Block evaluation took more than the expected <1p>' expandMacrosWith: aDuration)].
   
    ^result! !

!CvTbTestCase methodsFor: 'extensions' stamp: ''!
should: aBlock notTakeMoreThanMilliseconds: anInteger
    "For compatibility with other Smalltalks"

   self should: aBlock notTakeMoreThan: (Duration milliSeconds: anInteger).! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.071'!
should: aBlock raise: anExceptionalEvent 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent)
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.079'!
should: aBlock raise: anExceptionalEvent description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent)
		description: aString
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.083'!
should: aBlock raise: anExceptionalEvent whoseDescriptionDoesNotInclude: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: subString)
		description: aString
! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.087'!
should: aBlock raise: anExceptionalEvent whoseDescriptionIncludes: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: subString)
		description: aString
! !

!CvTbTestCase methodsFor: 'extensions' stamp: 'bs 5/22/2011 12:53:14.411'!
should: aBlock raise: anException withExceptionDo: anotherBlock 

	^self assert: (self executeShould: aBlock inScopeOf: anException withExceptionDo: anotherBlock)! !

!CvTbTestCase methodsFor: 'extensions' stamp: 'bs 5/22/2011 12:53:14.401'!
shouldFix: aBlock 

	^self should: aBlock raise: Exception! !

!CvTbTestCase methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.337'!
shouldPass
	"Unless the selector is in the list we get from #expectedFailures, we expect it to pass"
	^ (self expectedFailures includes: testSelector) not! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.091'!
shouldnt: aBlock
	self deny: aBlock value
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.097'!
shouldnt: aBlock description: aString
	self deny: aBlock value description: aString
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.101'!
shouldnt: aBlock raise: anExceptionalEvent 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.108'!
shouldnt: aBlock raise: anExceptionalEvent description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not 		description: aString
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.114'!
shouldnt: aBlock raise: anExceptionalEvent whoseDescriptionDoesNotInclude: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: subString) not
		description: aString
! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.118'!
shouldnt: aBlock raise: anExceptionalEvent whoseDescriptionIncludes: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: subString) not
		description: aString
! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.122'!
signalFailure: aString
	TestResult failure signal: aString! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:09.193'!
tbClass
	^ self activeDict at: self tbClassName! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:12.443'!
tbClassMethod
	^ self tbClass class >> self tbClassMethodName! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:16.869'!
tbClassMethodName
	^ #new! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:20.285'!
tbClassName
	^ #CvTbPerson ! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:38:51.897'!
tbMethod
	^ self tbClass >> self tbMethodName! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:38:44.335'!
tbMethodName
	^ #firstname! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2011 10:54:36.959'!
tbPackageInfo
	^ PackageOrganizer default packageOfClass: self tbClass! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2011 10:56:48.844'!
tbPackageName
	^ self tbPackageInfo name! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 16:15:38.804'!
tbSubclass
	^ self activeDict at: self tbSubclassName! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 16:15:25.728'!
tbSubclassName
	^ #CvTbEmployee! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:38:42.364'!
tbTestClass
	^ self activeDict at: self tbTestClassName! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:38:31.429'!
tbTestClassName
	^ #CvTbPersonTest! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 10:42:21.497'!
tbTestMethod
	^ self tbClass >> self tbTestMethodName! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 10:42:08.207'!
tbTestMethodName
	^ #testFirstname! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.319'!
tearDown! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.128'!
timeout: seconds
	"The timeout for a test should normally be set with a method annotation.
	However, for tests that are expected to run in images that do not support
	method annotations, the value may be set by setting the value from the
	#setUp method (i.e. prior to running the test method)."

	timeout := seconds! !

!CvTbTestCase methodsFor: 'running' stamp: ''!
timeout: aBlock after: seconds
	"Evaluate the argument block. Time out if the evaluation is not
	complete after the given number of seconds. Handle the situation
	that a timeout may occur after a failure (during debug)"

	| theProcess delay watchdog |

	"the block will be executed in the current process"
	theProcess := Processor activeProcess.
	delay := Delay forSeconds: seconds.

	"make a watchdog process"
	watchdog := [
		delay wait. 	"wait for timeout or completion"
		theProcess ifNotNil:[ theProcess signalException: 
			(TestFailure new messageText: 'Test timed out') ] 
	] newProcess.

	"Watchdog needs to run at high priority to do its job (but not at timing priority)"
	watchdog priority: Processor timingPriority-1.

	"catch the timeout signal"
	watchdog resume.				"start up the watchdog"
	^[aBlock on: TestFailure, Error, Halt do:[:ex|
		theProcess := nil.
		ex pass.
	]] ensure:[							"evaluate the receiver"
		theProcess := nil.				"it has completed, so ..."
		delay delaySemaphore signal.	"arrange for the watchdog to exit"
	]! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.132'!
timeoutForSetUp
	"Answer the timeout to use for setUp"

	| method |
	method := self class lookupSelector: testSelector asSymbol.
	(method pragmaAt: #timeout:) ifNotNil:[:tag| ^tag arguments first].
	^self defaultTimeout! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.231'!
timeoutForTest
	"Answer the timeout to use for this test"

	| method |
	method := self class lookupSelector: testSelector asSymbol.
	(method pragmaAt: #timeout:) ifNotNil:[:tag| ^tag arguments first].
	^timeout ifNil: [self defaultTimeout]! !
CvTbTestCase initialize!
